#! /usr/bin/python
# -*- Mode: Python -*-
# vi:si:et:sw=4:sts=4:ts=4

from twisted.spread import pb
from twisted.internet import reactor
from twisted.cred import credentials
from twisted.cred import checkers, portal

class Admin(pb.Referenceable):
    def __init__(self):
        print "admin: creating"

    def connected(self, perspective):
        print "admin: got perspective on manager ref:", perspective
        print "admin: callRemote('succeed') on manager"
        d = perspective.callRemote("succeed")
        d.addCallback(self.fail, perspective)

    def fail(self, somearg, perspective):
        print "admin: callRemote('fail') on manager"
        d = perspective.callRemote("fail")
        d.addErrback(self.errback)

    def errback(self, failure):
        print "admin: whaddayaknow, callRemote('fail') properly failed"
        print "admin: failure: %r, message:%s" % (
            failure, failure.getErrorMessage())

def startAdmin():
    admin = Admin()
    factory = pb.PBClientFactory()
    factory.unsafeTracebacks = 1
    reactor.connectTCP("localhost", 8900, factory)
    d = factory.login(credentials.UsernamePassword("admin", "pass"))
    d.addCallback(admin.connected)

if __name__ == '__main__':
    startAdmin()
    reactor.run()
