#! /usr/bin/python
# -*- Mode: Python -*-
# vi:si:et:sw=4:sts=4:ts=4

from twisted.spread import pb
from twisted.internet import reactor
from twisted.cred import credentials
from twisted.cred import checkers, portal

class Component(pb.Referenceable):
    def __init__(self):
        print "component: creating"
    def remote_succeed(self, source):
        print "component: %s asked me to succeed" % source
    def remote_fail(self, source):
        print "component: %s asked me to fail, going to raise pb.Error, I failed" % source
        raise pb.Error("I failed %s" % source)
    def connected(self, perspective):
        print "component: got perspective ref:", perspective
        print "component: asking it if it's ready"
        perspective.callRemote("ready")

def startComponent():
    factory = pb.PBClientFactory()
    factory.unsafeTracebacks = 1
    reactor.connectTCP("localhost", 8900, factory)
    component = Component()
    def1 = factory.login(credentials.UsernamePassword("component", "pass"),
        component)
    def1.addCallback(component.connected)

if __name__ == '__main__':
    startComponent()
    reactor.run()
